Index: src/boundary.cpp
===================================================================
--- src/boundary.cpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/boundary.cpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -3176,4 +821,8 @@
   bool freeTess = false;
   bool freeLC = false;
+  ofstream *tempstream = NULL;
+  char NumberName[255];
+  int TriangleFilesWritten = 0;
+
   *out << Verbose(1) << "Entering search for non convex hull. " << endl;
   if (Tess == NULL) {
@@ -3193,10 +842,10 @@
   }
 
-  Tess->Find_starting_triangle(out, mol, RADIUS, LCList);
+  Tess->Find_starting_triangle(out, RADIUS, LCList);
 
   baseline = Tess->LinesOnBoundary.begin();
   while ((baseline != Tess->LinesOnBoundary.end()) || (flag)) {
     if (baseline->second->TrianglesCount == 1) {
-      failflag = Tess->Find_next_suitable_triangle(out, mol, *(baseline->second), *(((baseline->second->triangles.begin()))->second), RADIUS, N, filename, LCList); //the line is there, so there is a triangle, but only one.
+      failflag = Tess->Find_next_suitable_triangle(out, *(baseline->second), *(((baseline->second->triangles.begin()))->second), RADIUS, N, LCList); //the line is there, so there is a triangle, but only one.
       flag = flag || failflag;
       if (!failflag)
@@ -3214,5 +863,58 @@
       flag = false;
     }
-  }
+
+    // write temporary envelope
+    if ((DoSingleStepOutput && (Tess->TrianglesOnBoundaryCount % 1 == 0))) { // if we have a new triangle and want to output each new triangle configuration
+      class BoundaryTriangleSet *triangle = (Tess->TrianglesOnBoundary.end()--)->second;
+      sprintf(NumberName, "-%04d-%s_%s_%s", TriangleFilesWritten, triangle->endpoints[0]->node->Name, triangle->endpoints[1]->node->Name, triangle->endpoints[2]->node->Name);
+      if (DoTecplotOutput) {
+        string NameofTempFile(filename);
+        NameofTempFile.append(NumberName);
+        for(size_t npos = NameofTempFile.find_first_of(' '); npos != string::npos; npos = NameofTempFile.find(' ', npos))
+        NameofTempFile.erase(npos, 1);
+        NameofTempFile.append(TecplotSuffix);
+        cout << Verbose(1) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+        tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
+        write_tecplot_file(out, tempstream, Tess, mol, TriangleFilesWritten);
+        tempstream->close();
+        tempstream->flush();
+        delete(tempstream);
+      }
+
+      if (DoRaster3DOutput) {
+        string NameofTempFile(filename);
+        NameofTempFile.append(NumberName);
+        for(size_t npos = NameofTempFile.find_first_of(' '); npos != string::npos; npos = NameofTempFile.find(' ', npos))
+        NameofTempFile.erase(npos, 1);
+        NameofTempFile.append(Raster3DSuffix);
+        cout << Verbose(1) << "Writing temporary non convex hull to file " << NameofTempFile << ".\n";
+        tempstream = new ofstream(NameofTempFile.c_str(), ios::trunc);
+        write_raster3d_file(out, tempstream, Tess, mol);
+//        // include the current position of the virtual sphere in the temporary raster3d file
+//        // make the circumsphere's center absolute again
+//        helper.CopyVector(BaseRay->endpoints[0]->node->node);
+//        helper.AddVector(BaseRay->endpoints[1]->node->node);
+//        helper.Scale(0.5);
+//        (*it)->OptCenter.AddVector(&helper);
+//        Vector *center = mol->DetermineCenterOfAll(out);
+//        (*it)->OptCenter.SubtractVector(center);
+//        delete(center);
+//        // and add to file plus translucency object
+//        *tempstream << "# current virtual sphere\n";
+//        *tempstream << "8\n  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0\n";
+//        *tempstream << "2\n  " << (*it)->OptCenter.x[0] << " "
+//          << (*it)->OptCenter.x[1] << " " << (*it)->OptCenter.x[2]
+//          << "\t" << RADIUS << "\t1 0 0\n";
+//        *tempstream << "9\n  terminating special property\n";
+        tempstream->close();
+        tempstream->flush();
+        delete(tempstream);
+      }
+      if (DoTecplotOutput || DoRaster3DOutput)
+        TriangleFilesWritten++;
+    }
+  }
+
+  // write final envelope
   if (filename != 0) {
     *out << Verbose(1) << "Writing final tecplot file\n";
Index: src/boundary.hpp
===================================================================
--- src/boundary.hpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/boundary.hpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -1,9 +1,4 @@
 #ifndef BOUNDARY_HPP_
 #define BOUNDARY_HPP_
-
-class BoundaryPointSet;
-class BoundaryLineSet;
-class BoundaryTriangleSet;
-class CandidateForTesselation;
 
 // include config.h
@@ -17,120 +12,17 @@
 #include <deque>
 
-#include <gsl/gsl_poly.h>
-
 #include "linkedcell.hpp"
 #include "molecules.hpp"
+#include "tesselation.hpp"
+#include "tesselationhelpers.hpp"
 
-template <typename T> void SetEndpointsOrdered(T endpoints[2], T endpoint1, T endpoint2)
-{
-  if (endpoint1->Nr < endpoint2->Nr) {
-    endpoints[0] = endpoint1;
-    endpoints[1] = endpoint2;
-  } else {
-    endpoints[0] = endpoint2;
-    endpoints[1] = endpoint1;
-  }
-};
-
-class BoundaryPointSet {
-  public:
-    BoundaryPointSet();
-    BoundaryPointSet(atom *Walker);
-    ~BoundaryPointSet();
-
-    void AddLine(class BoundaryLineSet *line);
-
-    LineMap lines;
-    int LinesCount;
-    atom *node;
-    int Nr;
-};
-
-class BoundaryLineSet {
-  public:
-    BoundaryLineSet();
-    BoundaryLineSet(class BoundaryPointSet *Point[2], int number);
-    ~BoundaryLineSet();
-
-    void AddTriangle(class BoundaryTriangleSet *triangle);
-    bool IsConnectedTo(class BoundaryLineSet *line);
-    bool ContainsBoundaryPoint(class BoundaryPointSet *point);
-    bool CheckConvexityCriterion(ofstream *out);
-
-    class BoundaryPointSet *endpoints[2];
-    TriangleMap triangles;
-    int TrianglesCount;
-    int Nr;
-};
-
-class BoundaryTriangleSet {
-  public:
-    BoundaryTriangleSet();
-    BoundaryTriangleSet(class BoundaryLineSet *line[3], int number);
-    ~BoundaryTriangleSet();
-
-    void GetNormalVector(Vector &NormalVector);
-    bool GetIntersectionInsideTriangle(ofstream *out, Vector *MolCenter, Vector *x, Vector *Intersection);
-    bool ContainsBoundaryLine(class BoundaryLineSet *line);
-    bool ContainsBoundaryPoint(class BoundaryPointSet *point);
-
-    class BoundaryPointSet *endpoints[3];
-    class BoundaryLineSet *lines[3];
-    Vector NormalVector;
-    int Nr;
-};
-
-
-class CandidateForTesselation {
-  public :
-  CandidateForTesselation(atom* candidate, BoundaryLineSet* currentBaseLine, Vector OptCandidateCenter, Vector OtherOptCandidateCenter);
-  ~CandidateForTesselation();
-  atom *point;
-  BoundaryLineSet *BaseLine;
-  Vector OptCenter;
-  Vector OtherOptCenter;
-};
-
-
-class Tesselation {
-  public:
-
-    Tesselation();
-    ~Tesselation();
-
-    void TesselateOnBoundary(ofstream *out, molecule *mol);
-    void GuessStartingTriangle(ofstream *out);
-    void AddPoint(atom * Walker);
-    void AddTrianglePoint(atom* Candidate, int n);
-    void AddTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, int n);
-    void AlwaysAddTriangleLine(class BoundaryPointSet *a, class BoundaryPointSet *b, int n);
-    void AddTriangle();
-    void Find_starting_triangle(ofstream *out, molecule* mol, const double RADIUS, LinkedCell *LC);
-    bool Find_next_suitable_triangle(ofstream *out, molecule* mol, BoundaryLineSet &Line, BoundaryTriangleSet &T, const double& RADIUS, int N, const char *filename, LinkedCell *LC);
-    int CheckPresenceOfTriangle(ofstream *out, atom *Candidates[3]);
-    void Find_next_suitable_point_via_Angle_of_Sphere(atom* a, atom* b, atom* c, atom* Candidate, atom* Parent, int RecursionLevel, Vector *Chord, Vector *direction1, Vector *OldNormal, Vector ReferencePoint, atom*& Opt_Candidate, double *Storage, const double RADIUS, molecule* mol);
-    class BoundaryTriangleSet * FindClosestTriangleToPoint(ofstream *out, Vector *x);
-    bool IsInside(Vector *pointer);
-    bool InsertStraddlingPoints(ofstream *out, molecule *mol);
-    bool CorrectConcaveBaselines(ofstream *out);
-
-    PointMap PointsOnBoundary;
-    LineMap LinesOnBoundary;
-    TriangleMap TrianglesOnBoundary;
-    class BoundaryPointSet *TPS[3]; //this is a Storage for pointers to triangle points, this and BPS[2] needed due to AddLine restrictions
-    class BoundaryPointSet *BPS[2];
-    class BoundaryLineSet *BLS[3];
-    class BoundaryTriangleSet *BTS;
-    int PointsOnBoundaryCount;
-    int LinesOnBoundaryCount;
-    int TrianglesOnBoundaryCount;
-    int TriangleFilesWritten;
-};
-
-
-ostream & operator << (ostream &ost, BoundaryPointSet &a);
-ostream & operator << (ostream &ost, BoundaryLineSet &a);
-ostream & operator << (ostream &ost, BoundaryTriangleSet &a);
-
+#define DEBUG 1
+#define DoSingleStepOutput 0
+#define DoTecplotOutput 1
+#define DoRaster3DOutput 1
+#define DoVRMLOutput 1
+#define TecplotSuffix ".dat"
+#define Raster3DSuffix ".r3d"
+#define VRMLSUffix ".wrl"
 
 double VolumeOfConvexEnvelope(ofstream *out, class Tesselation *TesselStruct, class config *configuration);
@@ -141,7 +33,5 @@
 void Find_non_convex_border(ofstream *out, molecule* mol, class Tesselation *T, class LinkedCell *LC, const char *tempbasename, const double RADIUS);
 void Find_next_suitable_point(class BoundaryTriangleSet *BaseTriangle, class BoundaryLineSet *BaseLine, atom*& OptCandidate, Vector *OptCandidateCenter, double *ShortestAngle, const double RADIUS, LinkedCell *LC);
-bool Choose_preferable_third_point(atom *Candidate, atom *OptCandidate, class BoundaryLineSet *BaseLine, atom *ThirdNode, Tesselation *Tess);
-bool existsIntersection(Vector point1, Vector point2, Vector point3, Vector point4);
-bool sortCandidates(CandidateForTesselation* candidate1, CandidateForTesselation* candidate2);
+Boundaries *GetBoundaryPoints(ofstream *out, molecule *mol);
 
 #endif /*BOUNDARY_HPP_*/
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/builder.cpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -1229,5 +1229,6 @@
   }
   molecules->SimpleMultiAdd(mol, src, N);
-  delete[](src);
+  delete(src);
+
   // ... and translate back
   for (MoleculeList::iterator ListRunner = molecules->ListOfMolecules.begin(); ListRunner != molecules->ListOfMolecules.end(); ListRunner++) {
Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/config.cpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -276,7 +276,7 @@
 
 /** Readin of Thermostat related values from parameter file.
- * \param *source parameter file
- */
-void config::InitThermostats(ifstream *source)
+ * \param *fb file buffer containing the config file
+ */
+void config::InitThermostats(class ConfigFileBuffer *fb)
 {
   char *thermo = MallocString(12, "IonsInitRead: thermo");
@@ -284,5 +284,5 @@
 
   // read desired Thermostat from file along with needed additional parameters
-  if (ParseForParameter(verbose,source,"Thermostat", 0, 1, 1, string_type, thermo, 1, optional)) {
+  if (ParseForParameter(verbose,fb,"Thermostat", 0, 1, 1, string_type, thermo, 1, optional)) {
     if (strcmp(thermo, ThermostatNames[0]) == 0) { // None
       if (ThermostatImplemented[0] == 1) {
@@ -295,5 +295,5 @@
       if (ThermostatImplemented[1] == 1) {
         Thermostat = Woodcock;
-        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read scaling frequency
+        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read scaling frequency
       } else {
         cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
@@ -303,5 +303,5 @@
       if (ThermostatImplemented[2] == 1) {
         Thermostat = Gaussian;
-        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read collision rate
+        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, int_type, &ScaleTempStep, 1, critical); // read collision rate
       } else {
         cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
@@ -311,6 +311,6 @@
       if (ThermostatImplemented[3] == 1) {
         Thermostat = Langevin;
-        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read gamma
-        if (ParseForParameter(verbose,source,"Thermostat", 0, 3, 1, double_type, &alpha, 1, optional)) {
+        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read gamma
+        if (ParseForParameter(verbose,fb,"Thermostat", 0, 3, 1, double_type, &alpha, 1, optional)) {
           cout << Verbose(2) << "Extended Stochastic Thermostat detected with interpolation coefficient " << alpha << "." << endl;
         } else {
@@ -324,5 +324,5 @@
       if (ThermostatImplemented[4] == 1) {
         Thermostat = Berendsen;
-        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read \tau_T
+        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &TempFrequency, 1, critical); // read \tau_T
       } else {
         cout << Verbose(1) << "Warning: " << ThermostatNames[0] << " thermostat not implemented, falling back to None." << endl;
@@ -332,5 +332,5 @@
       if (ThermostatImplemented[5] == 1) {
         Thermostat = NoseHoover;
-        ParseForParameter(verbose,source,"Thermostat", 0, 2, 1, double_type, &HooverMass, 1, critical); // read Hoovermass
+        ParseForParameter(verbose,fb,"Thermostat", 0, 2, 1, double_type, &HooverMass, 1, critical); // read Hoovermass
         alpha = 0.;
       } else {
@@ -704,4 +704,6 @@
     return;
   }
+  file->close();
+  delete(file);
   RetrieveConfigPathAndName(filename);
 
@@ -722,5 +724,5 @@
   double value[3];
   
-  InitThermostats(file);
+  InitThermostats(FileBuffer);
   
   /* Namen einlesen */
Index: src/ellipsoid.cpp
===================================================================
--- src/ellipsoid.cpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/ellipsoid.cpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -6,4 +6,8 @@
  */
 
+#include <gsl/gsl_multimin.h>
+#include <gsl/gsl_vector.h>
+
+#include "boundary.hpp"
 #include "ellipsoid.hpp"
 
@@ -221,6 +225,6 @@
   set<int>::iterator current;
   int index;
-  atom *Candidate = NULL;
-  LinkedAtoms *List = NULL;
+  TesselPoint *Candidate = NULL;
+  LinkedNodes *List = NULL;
   *out << Verbose(2) << "Begin of PickRandomPointSet" << endl;
 
@@ -288,9 +292,9 @@
 //            else
 //              *out << Verbose(2) << "Cell is empty ... " << endl;
-            for (LinkedAtoms::iterator Runner = List->begin(); Runner != List->end(); Runner++) {
+            for (LinkedNodes::iterator Runner = List->begin(); Runner != List->end(); Runner++) {
               if ((current != PickedAtomNrs.end()) && (*current == index)) {
                 Candidate = (*Runner);
                 *out << Verbose(2) << "Current picked node is " << **Runner << " with index " << index << "." << endl;
-                x[PointsPicked++].CopyVector(&(Candidate->x));    // we have one more atom picked
+                x[PointsPicked++].CopyVector(Candidate->node);    // we have one more atom picked
                 current++;    // next pre-picked atom
               }
@@ -338,5 +342,5 @@
       //*out << Verbose(3) << "Current node is " << *Runner->second->node << " with " << value << " ... " << threshold << ": ";
       if (value > threshold) {
-        x[PointsPicked].CopyVector(&(Runner->second->node->x));
+        x[PointsPicked].CopyVector(Runner->second->node->node);
         PointsPicked++;
         //*out << "IN." << endl;
@@ -375,5 +379,5 @@
   Center.Zero();
   for (PointMap::iterator Runner = T->PointsOnBoundary.begin(); Runner != T->PointsOnBoundary.end(); Runner++)
-    Center.AddVector(&Runner->second->node->x);
+    Center.AddVector(Runner->second->node->node);
   Center.Scale(1./T->PointsOnBoundaryCount);
   *out << Verbose(1) << "Center is at " << Center << "." << endl;
Index: src/ellipsoid.hpp
===================================================================
--- src/ellipsoid.hpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/ellipsoid.hpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -14,7 +14,5 @@
 #endif
 
-#include <cstdlib>
-
-#include "boundary.hpp"
+#include "linkedcell.hpp"
 #include "vector.hpp"
 
Index: src/linkedcell.cpp
===================================================================
--- src/linkedcell.cpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/linkedcell.cpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -1,4 +1,8 @@
 #include "linkedcell.hpp"
 #include "molecules.hpp"
+#include "tesselation.hpp"
+
+// ========================================================= class LinkedCell ===========================================
+
 
 /** Constructor for class LinkedCell.
@@ -16,10 +20,10 @@
 
 /** Puts all atoms in \a *mol into a linked cell list with cell's lengths of \a RADIUS
- * \param *mol molecule structure with all Atom's
+ * \param *set LCNodeSet class with all LCNode's
  * \param RADIUS edge length of cells
  */
-LinkedCell::LinkedCell(molecule *mol, double radius)
+LinkedCell::LinkedCell(PointCloud *set, double radius)
 {
-  atom *Walker = NULL;
+  TesselPoint *Walker = NULL;
 
   RADIUS = radius;
@@ -31,26 +35,29 @@
   min.Zero();
   cout << Verbose(1) << "Begin of LinkedCell" << endl;
-  if (mol->start->next == mol->end) {
-    cerr << "ERROR: molecule contains no atoms!" << endl;
+  if (set->IsEmpty()) {
+    cerr << "ERROR: set contains no linked cell nodes!" << endl;
     return;
   }
   // 1. find max and min per axis of atoms
-  Walker = mol->start->next;
+  set->GoToFirst();
+  Walker = set->GetPoint();
   for (int i=0;i<NDIM;i++) {
-    max.x[i] = Walker->x.x[i];
-    min.x[i] = Walker->x.x[i];
+    max.x[i] = Walker->node->x[i];
+    min.x[i] = Walker->node->x[i];
   }
-  while (Walker != mol->end) {
+  set->GoToFirst();
+  while (!set->IsLast()) {
+    Walker = set->GetPoint();
     for (int i=0;i<NDIM;i++) {
-      if (max.x[i] < Walker->x.x[i])
-        max.x[i] = Walker->x.x[i];
-      if (min.x[i] > Walker->x.x[i])
-        min.x[i] = Walker->x.x[i];
+      if (max.x[i] < Walker->node->x[i])
+        max.x[i] = Walker->node->x[i];
+      if (min.x[i] > Walker->node->x[i])
+        min.x[i] = Walker->node->x[i];
     }
-    Walker = Walker->next;
+    set->GoToNext();
   }
   cout << Verbose(2) << "Bounding box is " << min << " and " << max << "." << endl;
 
-  // 2. find then umber of cells per axis
+  // 2. find then number of cells per axis
   for (int i=0;i<NDIM;i++) {
     N[i] = (int)floor((max.x[i] - min.x[i])/RADIUS)+1;
@@ -64,5 +71,5 @@
     return;
   }
-  LC = new LinkedAtoms[N[0]*N[1]*N[2]];
+  LC = new LinkedNodes[N[0]*N[1]*N[2]];
   for (index=0;index<N[0]*N[1]*N[2];index++) {
     LC [index].clear();
@@ -72,13 +79,14 @@
   // 4. put each atom into its respective cell
   cout << Verbose(2) << "Filling cells ... ";
-  Walker = mol->start;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
+  set->GoToFirst();
+  while (!set->IsLast()) {
+    Walker = set->GetPoint();
     for (int i=0;i<NDIM;i++) {
-      n[i] = (int)floor((Walker->x.x[i] - min.x[i])/RADIUS);
+      n[i] = (int)floor((Walker->node->x[i] - min.x[i])/RADIUS);
     }
     index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
     LC[index].push_back(Walker);
     //cout << Verbose(2) << *Walker << " goes into cell " << n[0] << ", " << n[1] << ", " << n[2] << " with No. " << index << "." << endl;
+    set->GoToNext();
   }
   cout << "done."  << endl;
@@ -118,5 +126,5 @@
  * \return LinkedAtoms pointer to current cell, NULL if LinkedCell::n[] are out of bounds.
  */
-LinkedAtoms* LinkedCell::GetCurrentCell()
+LinkedNodes* LinkedCell::GetCurrentCell()
 {
   if (CheckBounds()) {
@@ -128,21 +136,21 @@
 };
 
-/** Calculates the index for a given atom *Walker.
- * \param *Walker atom to set index to
+/** Calculates the index for a given LCNode *Walker.
+ * \param *Walker LCNode to set index tos
  * \return if the atom is also found in this cell - true, else - false
  */
-bool LinkedCell::SetIndexToAtom(atom *Walker)
+bool LinkedCell::SetIndexToNode(TesselPoint *Walker)
 {
   bool status = false;
   for (int i=0;i<NDIM;i++) {
-    n[i] = (int)floor((Walker->x.x[i] - min.x[i])/RADIUS);
+    n[i] = (int)floor((Walker->node->x[i] - min.x[i])/RADIUS);
   }
   index = n[0] * N[1] * N[2] + n[1] * N[2] + n[2];
   if (CheckBounds()) {
-    for (LinkedAtoms::iterator Runner = LC[index].begin(); Runner != LC[index].end(); Runner++)
+    for (LinkedNodes::iterator Runner = LC[index].begin(); Runner != LC[index].end(); Runner++)
       status = status || ((*Runner) == Walker);
     return status;
   } else {
-    cerr << Verbose(1) << "ERROR: Atom "<< *Walker << " at " << Walker->x << " is out of bounds." << endl;
+    cerr << Verbose(1) << "ERROR: Node at " << *Walker << " is out of bounds." << endl;
     return false;
   }
Index: src/linkedcell.hpp
===================================================================
--- src/linkedcell.hpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/linkedcell.hpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -1,4 +1,16 @@
+/*
+ * linkedcell.hpp
+ *
+ *  If the linked cell should be usable, the class has to inherit LCNodeSet and the nodes (containing the Vectors) have to inherit LCNode. This works well
+ *  for molecule and atom classes.
+ *
+ *  Created on: Aug 3, 2009
+ *      Author: heber
+ */
+
 #ifndef LINKEDCELL_HPP_
 #define LINKEDCELL_HPP_
+
+using namespace std;
 
 // include config.h
@@ -7,13 +19,22 @@
 #endif
 
-#include "molecules.hpp"
+#include <list>
 
-#define LinkedAtoms list <atom *>
+#include "defs.hpp"
+#include "helpers.hpp"
+#include "vector.hpp"
 
-class LinkedCell{
+class TesselPoint;
+class PointCloud;
+
+#define LinkedNodes list<TesselPoint *>
+
+/** Linked Cell class for containing Vectors in real space efficiently.
+ */
+class LinkedCell {
   public:
     Vector max;       // upper boundary
     Vector min;       // lower boundary
-    LinkedAtoms *LC;  // linked cell list
+    LinkedNodes *LC;  // linked cell list
     double RADIUS;    // cell edge length
     int N[NDIM];      // number of cells per axis
@@ -22,15 +43,15 @@
 
     LinkedCell();
-    LinkedCell(molecule *mol, double RADIUS);
+    LinkedCell(PointCloud *set, double RADIUS);
     ~LinkedCell();
-    LinkedAtoms* GetCurrentCell();
-    bool SetIndexToAtom(atom *Walker);
+    LinkedNodes* GetCurrentCell();
+    bool SetIndexToNode(TesselPoint *Walker);
     bool SetIndexToVector(Vector *x);
     bool CheckBounds();
 
     // not implemented yet
-    bool AddAtom(atom *Walker);
-    bool DeleteAtom(atom *Walker);
-    bool MoveAtom(atom *Walker);
+    bool AddNode(Vector *Walker);
+    bool DeleteNode(Vector *Walker);
+    bool MoveNode(Vector *Walker);
 };
 
Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/molecules.cpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -42,4 +42,5 @@
   end->father = NULL;
   link(start,end);
+  InternalPointer = start;
   // init bond chain list
   first = new bond(start, end, 1, -1);
@@ -82,4 +83,82 @@
   delete(end);
   delete(start);
+};
+
+
+/** Determine center of all atoms.
+ * \param *out output stream for debugging
+ * \return pointer to allocated with central coordinates
+ */
+Vector *molecule::GetCenter(ofstream *out)
+{
+  Vector *center = DetermineCenterOfAll(out);
+  return center;
+};
+
+/** Return current atom in the list.
+ * \return pointer to atom or NULL if none present
+ */
+TesselPoint *molecule::GetPoint()
+{
+  if ((InternalPointer != start) && (InternalPointer != end))
+    return InternalPointer;
+  else
+    return NULL;
+};
+
+/** Return pointer to one after last atom in the list.
+ * \return pointer to end marker
+ */
+TesselPoint *molecule::GetTerminalPoint()
+{
+  return end;
+};
+
+/** Go to next atom.
+ * Stops at last one.
+ */
+void molecule::GoToNext()
+{
+  if (InternalPointer->next != end)
+    InternalPointer = InternalPointer->next;
+};
+
+/** Go to previous atom.
+ * Stops at first one.
+ */
+void molecule::GoToPrevious()
+{
+  if (InternalPointer->previous != start)
+    InternalPointer = InternalPointer->previous;
+};
+
+/** Goes to first atom.
+ */
+void molecule::GoToFirst()
+{
+  InternalPointer = start->next;
+};
+
+/** Goes to last atom.
+ */
+void molecule::GoToLast()
+{
+  InternalPointer = end->previous;
+};
+
+/** Checks whether we have any atoms in molecule.
+ * \return true - no atoms, false - not empty
+ */
+bool molecule::IsEmpty()
+{
+  return (start->next == end);
+};
+
+/** Checks whether we are at the last atom
+ * \return true - current atom is last one, false - is not last one
+ */
+bool molecule::IsLast()
+{
+  return (InternalPointer->next == end);
 };
 
Index: src/molecules.hpp
===================================================================
--- src/molecules.hpp	(revision 2319ed7194f122bf4ff43ec6b7ea796f88df7fb3)
+++ src/molecules.hpp	(revision 357fba6ccb2cf9e2d97f501d5968558a706028a5)
@@ -25,12 +25,14 @@
 #include <vector>
 
+#include "atom.hpp"
+#include "bond.hpp"
 #include "helpers.hpp"
+#include "linkedcell.hpp"
 #include "parser.hpp"
 #include "periodentafel.hpp"
 #include "stackclass.hpp"
+#include "tesselation.hpp"
 #include "vector.hpp"
 
-class atom;
-class bond;
 class config;
 class molecule;
@@ -38,5 +40,4 @@
 class MoleculeListClass;
 class Verbose;
-class Tesselation;
 
 /******************************** Some definitions for easier reading **********************************/
@@ -58,20 +59,4 @@
 #define BoundariesTestPair pair< Boundaries::iterator, bool>
 
-#define PointMap map < int, class BoundaryPointSet * >
-#define PointPair pair < int, class BoundaryPointSet * >
-#define PointTestPair pair < PointMap::iterator, bool >
-#define CandidateList list <class CandidateForTesselation *>
-
-#define LineMap multimap < int, class BoundaryLineSet * >
-#define LinePair pair < int, class BoundaryLineSet * >
-#define LineTestPair pair < LineMap::iterator, bool >
-
-#define TriangleMap map < int, class BoundaryTriangleSet * >
-#define TrianglePair pair < int, class BoundaryTriangleSet * >
-#define TriangleTestPair pair < TrianglePair::iterator, bool >
-
-#define DistanceMultiMap multimap <double, pair < PointMap::iterator, PointMap::iterator> >
-#define DistanceMultiMapPair pair <double, pair < PointMap::iterator, PointMap::iterator> >
-
 #define MoleculeList list <molecule *>
 #define MoleculeListTest pair <MoleculeList::iterator, bool>
@@ -125,81 +110,4 @@
 };
 
-/** Single atom.
- * Class incoporates position, type
- */
-class atom {
-  public:
-    Vector x;       //!< coordinate array of atom, giving position within cell
-    Vector v;       //!< velocity array of atom
-    element *type;  //!< pointing to element
-    atom *previous; //!< previous atom in molecule list
-    atom *next;     //!< next atom in molecule list
-    atom *father;   //!< In many-body bond order fragmentations points to originating atom
-    atom *Ancestor; //!< "Father" in Depth-First-Search
-    char *Name;      //!< unique name used during many-body bond-order fragmentation
-    int FixedIon;   //!< config variable that states whether forces act on the ion or not
-    int *sort;      //!< sort criteria
-    int nr;         //!< continuous, unique number
-    int GraphNr;      //!< unique number, given in DepthFirstSearchAnalysis()
-    int *ComponentNr;//!< belongs to this nonseparable components, given in DepthFirstSearchAnalysis() (if more than one, then is SeparationVertex)
-    int LowpointNr; //!< needed in DepthFirstSearchAnalysis() to detect nonseparable components, is the lowest possible number of an atom to reach via tree edges only followed by at most one back edge.
-    bool SeparationVertex; //!< whether this atom separates off subsets of atoms or not, determined in DepthFirstSearchAnalysis()
-    bool IsCyclic;        //!< whether atom belong to as cycle or not, determined in DepthFirstSearchAnalysis()
-    unsigned char AdaptiveOrder;  //!< current present bond order at site (0 means "not set")
-    bool MaxOrder;  //!< whether this atom as a root in fragmentation still creates more fragments on higher orders or not
-
-  atom();
-  atom(class atom *pointer);
-  ~atom();
-
-  bool Output(int ElementNo, int AtomNo, ofstream *out, const char *comment = NULL) const;
-  bool OutputXYZLine(ofstream *out) const;
-  atom *GetTrueFather();
-  bool Compare(atom &ptr);
-
-  private:
-};
-
-ostream & operator << (ostream &ost, const atom &a);
-
-/** Bonds between atoms.
- * Class incorporates bonds between atoms in a molecule,
- * used to derive tge fragments in many-body bond order
- * calculations.
- */
-class bond {
-  public:
-    atom *leftatom;    //!< first bond partner
-    atom *rightatom;  //!< second bond partner
-    bond *previous; //!< previous atom in molecule list
-    bond *next;     //!< next atom in molecule list
-    int HydrogenBond;  //!< Number of hydrogen atoms in the bond
-    int BondDegree;    //!< single, double, triple, ... bond
-    int nr;           //!< unique number in a molecule, updated by molecule::CreateAdjacencyList()
-    bool Cyclic;      //!< flag whether bond is part of a cycle or not, given in DepthFirstSearchAnalysis()
-    enum EdgeType Type;//!< whether this is a tree or back edge
-
-  atom * GetOtherAtom(atom *Atom) const;
-  bond * GetFirstBond();
-  bond * GetLastBond();
-
-  bool MarkUsed(enum Shading color);
-  enum Shading IsUsed();
-  void ResetUsed();
-  bool Contains(const atom *ptr);
-  bool Contains(const int nr);
-
-  bond();
-  bond(atom *left, atom *right);
-  bond(atom *left, atom *right, int degree);
-  bond(atom *left, atom *right, int degree, int number);
-  ~bond();
-
-  private:
-    enum Shading Used;        //!< marker in depth-first search, DepthFirstSearchAnalysis()
-};
-
-
-ostream & operator << (ostream &ost, const bond &b);
 
 #define MaxThermostats 6      //!< maximum number of thermostat entries in Ions#ThermostatNames and Ions#ThermostatImplemented 
@@ -210,5 +118,5 @@
  * Class incorporates number of types
  */
-class molecule {
+class molecule : public PointCloud {
   public:
     double cell_size[6];//!< cell size
@@ -234,7 +142,19 @@
     char name[MAXSTRINGSIZE];         //!< arbitrary name
     int IndexNr;        //!< index of molecule in a MoleculeListClass
+    class Tesselation *TesselStruct;
 
   molecule(periodentafel *teil);
   ~molecule();
+
+  // re-definition of virtual functions from PointCloud
+  Vector *GetCenter(ofstream *out);
+  TesselPoint *GetPoint();
+  TesselPoint *GetTerminalPoint();
+  void GoToNext();
+  void GoToPrevious();
+  void GoToFirst();
+  void GoToLast();
+  bool IsEmpty();
+  bool IsLast();
 
   /// remove atoms from molecule.
@@ -350,4 +270,5 @@
   private:
   int last_atom;      //!< number given to last atom
+  atom *InternalPointer;  //!< internal pointer for PointCloud
 };
 
@@ -524,5 +445,5 @@
   char *GetDefaultPath() const;
   void SetDefaultPath(const char *path);
-  void InitThermostats(ifstream *source);
+  void InitThermostats(class ConfigFileBuffer *fb);
 };
 
